<template>
  <div ref="editor" />
</template>

<script>
import { edit } from "ace-builds";
import "ace-builds/webpack-resolver";
import darkTheme from "ace-builds/src-noconflict/theme-one_dark";
import lightTheme from "ace-builds/src-noconflict/theme-chrome";
import { timeout } from "assets/util/general";
import { themeMixin } from "@/components/Mixins/theme";

export default {
  mixins: [themeMixin],
  props: {
    value: {
      type: String,
      required: true,
    },
    lang: {
      type: String,
      default: "text",
    },
    readOnly: {
      type: Boolean,
    },
  },
  computed: {
    theme() {
      return this.isDark ? darkTheme : lightTheme;
    },
  },
  watch: {
    async value(val) {
      // 1s timeout before setting val of editor to make sure value has enough time to be updated
      // helps to remedy the bug of editor not updating although value has been changed
      await timeout(1000);
      this._editor.setValue(val, 1);
    },
    isDark() {
      this._editor.setTheme(this.theme);
    },
  },
  mounted() {
    this._editor = edit(this.$refs.editor, {
      readOnly: this.readOnly,
      value: this.value,
      mode: "ace/mode/" + this.lang,
      theme: this.theme,
      fontSize: 16,
      maxLines: Infinity,
      foldStyle: "markbeginend",
      wrap: "free",
      printMargin: false,
    });

    this._editor.on("change", () => {
      this.$emit("update:value", this._editor.getValue());
    });
  },
  beforeUnmount() {
    this._editor?.destroy();
  },
};
</script>
